package Puma::Devel::Session;

=copyright

	Puma - Perl Universal Markup
	Copyright (c) 2001, Ingmar Ellenberger.  All rights reserved.
	Software is distributed AS IS.  No warranties, expressed or implied.

	This license is temporary, pending the selection of an appropriate
	open-source license.

=description

=cut

# A cookie manager with pluggable storage methods.
# Must allow application scoped data, whether through separate cookies, or
#    (more preferrably), through separate database entries.

sub new {
	# ---  be a nice constructor ---
	my $this = shift;
	my $self = bless {}, ref($this) || $this;

	# TODO: switch to named parameters
	# TODO: new parameters: timeout (seconds), config object
	# --- next two params: app name (context) and session ID (uid)
	my ($context, $uid) = @_;
	$self->{context} = $context;
	$self->{uid} = $uid;

	$self->{_timeout} = 300;

	# TODO: use config object to determine state object
	my $state = new Puma::State::DDState(
		Location => 'Session',
		Context  => $self->{context},
		UID      => $self->{uid},
	);

	# TODO: test for expored stste
}

# === session object methods ================================================

# $Session->{SessionID}
# $Session->{Timeout} [= $minutes]
# $Session->Abandon()
# $Session->Lock() 
# $Session->UnLock()

# === hash tie stuff ========================================================

# --- a list of reserved keys in the hash tie ---
my $reserved = qr/_(timeout|context|uid)/s;

sub TIEHASH {
	my ($this, $hash) = (shift, shift || {});
	return bless $hash, ref($this) || $this;
}

sub STORE {
	my ($self, $key, $value) = @_;
	return $self->{content}->{$key} = $value unless $key =~ /$reserved/;
	# add any special processing here ...
	return $self->{$key} = $value;
}

sub FETCH    { $_[0]->{content}->{$_[1]} }
sub FIRSTKEY { my $a = scalar keys %{$_[0]->{content}}; each %{$_[0]->{content}} }
sub NEXTKEY  { each %{$_[0]->{content}} }
sub EXISTS   { exists $_[0]->{content}->{$_[1]} }
sub DELETE   { delete $_[0]->{content}->{$_[1]} }
sub CLEAR    { %{$_[0]->{content}} = () }

1;

__END__
