#!/usr/bin/perl -w

#use lib '/home/ingmar/lib'; # now using /usr/lib/perl5/site_perl
use Puma::Util::Buffer;
use Puma::SP::Server;
use Puma::Parser::SP;
use Data::Dumper;

use strict;

my $filename = $ENV{PATH_TRANSLATED};

my $server = new Puma::SP::Server;
print $server->header;

my $parser = new Puma::Parser::SP;
my $ptree = $parser->parseFile($filename);
my $pdump = Data::Dumper->Dump([$ptree], ['ptree']);
my $code = $parser->codify($ptree);

my $buffer = new Puma::Util::Buffer;
my $output = $buffer->capture( sub {
	eval($code);
});

if ($@) {
	print "Puma Server Pages Error : $@<hr>\n";
	my $lcode;
	my @lines = split /\n/, $code;
	my $linenumber = 1;
	foreach my $line (@lines) {
		$line =~ s/</&lt;/g;
		$lcode .= $linenumber++ .": $line\n";
	}
	print "<pre><code>$lcode</code></pre>\n";
} else {
	print $output ."\n";
}
