package Puma::Tag;
use ibase Puma::Core;

=copyright

	Puma - Perl Universal Markup
	Copyright (c) 2001, Ingmar Ellenberger.  All rights reserved.
	Software is distributed AS IS.  No warranties, expressed or implied.

	This license is temporary, pending the selection of an appropriate
	open-source license.

=description

	Tag.pm - Abstract class for tags

=cut

sub render { }
sub renderChildren {
	my $self = shift;

	# --- get the current code ---
	return unless $self->{_codestack} && @{$self->{_codestack}};
	my $code = $self->{_codestack}->[0];

	return $code->();
}

sub _render ($, $%, $&) {
	my ($self, $name, $params, $code) = @_;

	# --- push the code to the stack ---
	# TODO: find a more elegant way to write this
	#       hash-element-array-dereference nonsense
	my $cstack = $self->{_codestack} || [];
	unshift @$cstack, $code;
	$self->{_codestack} = $cstack;

	# --- call the public render routine ---
	my $retval = $self->render($name, %$params);

	# --- pop the code off the stack ---
	shift @$cstack;

	return $retval;
}

1;
